//---------------------------------------------------------------------------

#pragma hdrstop

#include "Expression.h"
#include "Stack.h"
#include <math.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------
Expression::Expression(const char * str):
  exp(str)
{
}
//---------------------------------------------------------------------------
Expression::Expression(const Expression& other):
  exp(other.exp)
{
}
//---------------------------------------------------------------------------
Expression::~Expression()
{
}
//---------------------------------------------------------------------------
bool Expression::Check() const{
  Stack <char> s;
//  char c,d;
  for(int i=1; i <= exp.Length(); i++) {
    char ch = exp[i];
    if( ch=='(' ||  ch=='[' ||  ch=='{' )
      s.Push(ch);
    else if ( ch==')' ||  ch==']' ||  ch=='}' ) {
      if(s.IsEmpty())
        return false;
      char par = s.Pop();
      if(!Match(par,ch))
      return false;
    }
  }
  if(s.IsEmpty())
    return true;
  return false;
}
//---------------------------------------------------------------------------
bool Expression::Match(char c, char d) const{
  switch (c) {
    case '(' : return (d==')');
    case '[' : return (d==']');
    case '{' : return (d=='}');
    default  : return false;
  }
}
//---------------------------------------------------------------------------
//AnsiString Expression::PosFixa() {
/*  AnsiString posfixa = "";
  Stack <char> s;
  //char x1=0;
  for(int i=1; i<=exp.Length() ; i++)
    {
        char ch = exp[i];
        if(isSignal(ch)) {
            if(s.IsEmpty())
                s.Push(ch);
            else
                if(Prioridade(ch) > Prioridade(s.Peek()))
                    s.Push(ch);
                else
                {
                    while(!s.IsEmpty() && Prioridade(ch)<=Prioridade(s.Peek()))
                        posfixa +=s.Pop();
                    s.Push(ch);
                }
        }
        else if(ch=='(')
            s.Push('(');
        else if(ch==')') {
            while(!s.IsEmpty() && s.Peek()!='(')
                posfixa +=s.Pop();
            s.Pop();
        }
        else
            posfixa += ch;
    }
  while(!s.IsEmpty())
    posfixa += s.Pop();

  return posfixa;
  */
//}
//---------------------------------------------------------------------------
int Expression::Prioridade(String x) const {
  /*switch (x) {
    case '+' : return 1;
    case '-' : return 1;
    case '*' : return 2;
    case '/' : return 2;
    case '^' : return 3;
    default : return 0;
  }*/
  if(x == "+") return 1;
  if(x == "-") return 1;
  if(x == "/") return 2;
  if(x == "*") return 2;
  if(x == "^") return 3;
  if(x == "Sqrt") return 4;
  if(x == "cos") return 4;
  if(x == "sin") return 4;
  return 0 ;
}

//---------------------------------------------------------------------------
bool Expression::isSignal(String x)
{
    if( x == '+' || x=='/' || x=='*' || x=='-' || x == '^')
        return( true );
    return( false );
}
//---------------------------------------------------------------------------
String Expression::PutSpace(){
    String newstr;
    for(int i = 1; i <= exp.Length(); i++){
        if(exp[i] == ' ') continue;
          if(isSignal(exp[i]) || exp[i] == ')' || exp[i] == '('){
            newstr+=" ";
            newstr+=exp[i];
            newstr+=" ";
          }
          else
            newstr+=exp[i];
    }
    return newstr;
}
//-------------------------------------------------------------------------
String Expression:: newPosFixa(){
     String posfix;
     Stack<String> s;
     exp = PutSpace();
     IteratorString it(exp);
     while(it.HasMoreElements()){
        String bloco= it.Current();
        it.Next();
        if(isSignal(bloco[1]) || isFunction(bloco[1])){
            if(s.IsEmpty()) s.Push(bloco);
            else{
                while (!s.IsEmpty() && Prioridade(bloco) <= Prioridade(s.Peek())){
                    posfix += s.Pop();
                    posfix += " ";
                }
                s.Push(bloco);
            }
        }
        else {
          if (bloco[1]=='(')
            s.Push(bloco);
          else {
            if (bloco[1]==')') {
              while (s.Peek()!='('){
                posfix += s.Pop();
                posfix += " ";
              }
            s.Pop();

            }
            else
            {
              posfix += bloco;
              posfix += " ";
            }
          }
        }
     }
    while(!s.IsEmpty()){
        posfix += s.Pop();
        posfix+= " ";
    }
   return posfix;
}


//-----------------------------------------------------------------
bool Expression::isFunction(String x)
{
    if( x == "c" || x=="s" || x=="S")
        return( true );
    return( false );
}
//-----------------------------------------------------------------
double Expression ::Calcular()
{
    double r=0;   //direita
    double l=0;   //esquerda
    Stack <double> s;
    String tmp  = newPosFixa();
    IteratorString it(tmp);
    while(it.HasMoreElements()){
        String bloco = it.Current();
        it.Next();

        if(bloco[1]=='x' || bloco[1]=='y' || bloco[1]=='z'){
           if(bloco[1]=='x')
              s.Push(x);
           else if(bloco[1]=='y')
              s.Push(y);
           else if(bloco[1]=='z')
              s.Push(z);
       }else  

        if(!isSignal(bloco[1]) && !isFunction(bloco[1]) ){

            s.Push(AnsiString(bloco.c_str()).ToDouble())  ;
        }
        else{

            if(!isFunction(bloco[1])){
                r = AnsiString(s.Pop()).ToDouble();
                l = AnsiString(s.Pop()).ToDouble();
                s.Push(opCalc(l, bloco[1], r));
            }
            else{

                l = AnsiString(s.Pop()).ToDouble();
                s.Push(opCalc(l, bloco[1], 0));
            }
        }
    }  
    return s.Pop();
}

//------------------------------------------------------
double Expression::opCalc(double l, String sig, double r)
{
    double result = 0;
    if(sig == "+") result = l + r;
    if(sig == "-") result = l - r;
    if(sig == "*") result = l * r;
    if(sig == "/"){
        if( r != 0){
            result = l/r;
        }
        else{
            result = 0; //nao pode realizar divisoes por zero, o resultado  zero
        }
    }
    if(sig == "c") result = cos(l);
    if(sig == "s") result = sin(l);
    if(sig == "^") result = pow(l, r);
    if(sig == "S") result = sqrt(l);
    return result;
}

//---------------------------------------------------------------
double Expression::getX(){
   return this->x;
}
//---------------------------------------------------------------
double Expression::getY(){
   return this->y;
}
//---------------------------------------------------------------
double Expression::getZ(){
   return this->z;
}
//---------------------------------------------------------------
void Expression::setX(double x){
   this->x = x;
}
//---------------------------------------------------------------
void Expression::setY(double y){
   this->y = y;
}
//---------------------------------------------------------------
void Expression::setZ(double z){
   this->z = z;
}
 //---------------------------------------------------------------
